module WordAnalysis
  def downcased_word_list
    downcase.scan(/[\w']+/)
  end
end

module TextAnalysis
  def word_list
    scan(/[\w']+/)
  end
end

module WordCounter
  def word_count
    downcase.scan(/[\w']+/).inject(Hash.new(0)) do |result, word|
      result[word] += 1
      result
    end
  end
end

class String
  include WordAnalysis
  include WordCounter
  include TextAnalysis
end

p "Hello, World!".word_list
p "Hello, World!".downcased_word_list
p "Hello, World!".word_count
